<template>
  <st-content :heading="title">
    <st-back-btn></st-back-btn>
    <v-row justify="end" class="fill-height">
      <v-col md="9">
        <st-calendar
          ref="calendar"
          styleInterval="past"
          :idTutor="idTutor"
          :units="units"
          :currUnit="currUnit"
        />
      </v-col>
      <v-col md="3">
        <v-row>
          <v-col>
            <st-primary-btn nombre="REGISTRAR HORARIO" @click="SaveChanges" :loading="loading" />
          </v-col>
        </v-row>
        <div class="space"></div>
        <div class="content-body">
          <v-row>
            <v-col>
              <st-subtitle text="Replicar horario en rango de fechas:" />
            </v-col>
          </v-row>
          <v-row>
            <v-col>
              <v-menu
                ref="menu"
                v-model="menu"
                :close-on-content-click="false"
                :return-value.sync="date"
                transition="scale-transition"
                offset-y
                min-width="290px"
              >
                <template v-slot:activator="{ on }">
                  <v-text-field v-model="dateRangeText" label="Rango de fechas" readonly v-on="on"></v-text-field>
                </template>
                <v-date-picker v-model="date" no-title scrollable range locale="es">
                  <v-spacer></v-spacer>
                  <v-btn text color="primary" @click="menu = false">Cancelar</v-btn>
                  <v-btn text color="primary" @click="cambioFecha">OK</v-btn>
                </v-date-picker>
              </v-menu>
            </v-col>
          </v-row>
          <v-row>
            <v-col>
              <st-secondary-btn nombre="REPLICAR HORARIO" @click="Repeat" :loading="loadingRep" />
            </v-col>
          </v-row>
        </div>
        <div class="space"></div>
        <div class="content-body">
          <v-row>
            <v-col>
              <st-legend :legend="legend" />
            </v-col>
          </v-row>
        </div>
      </v-col>
    </v-row>
  </st-content>
</template>

<script>
import Calendar from "@/components/Calendar.vue"
import ColorLegend from "@/components/ColorLegend.vue"
export default {
  data() {
    return {
      ini: "",
      nombreBtn : "REGISTRAR HORARIO",
      dialog:false,
      currUnit: "",
      loadingRep : false,
      loading: false,
      date: [],
      menu: false,
      legend: [
         { color: "#F2703D", text: "Horario reservado" },
        { color: "#FFFFFF", text: "Horario disponible" },
        { color: "#999999", text: "Horario no disponible" },
        { color: "#01579B", text: "Horario sin unidad" },
        { color: "#4DB6AC", text: "Horario con unidad" }
      ],
      units: [
        // {color: '#8E2136', idUnit:'1', text: 'Ciencias e ingenieria'},
        //{color: '#006181', idUnit:'2', text: 'Ingenieria informatica'},
        //{color: '#51EAB1', idUnit:'3', text: 'Arquitectura y Urbanismo'}
      ],
      unit : null
    };
  },
  methods: {
    newUnit(value) {
      this.currUnit = value;
      let ind = this.units.findIndex(unit => unit.idUnidad === value);
      this.nombreBtn= "REGISTRAR HORARIO DE " + this.units[ind].nombre
      this.$refs.calendar.updateUnit(value)
      this.$refs.calendar.updateUnit2()
    },
    cambioFecha(){
      this.$refs.menu.save(this.date)
      //this.$emit('cambioFecha', this.date);
    },
    update() {
      this.$refs.calendar.ini();
    },
    SaveChanges() {
      this.loading = true;
      let events = this.$refs.calendar.getEvents(this.currUnit); //[];
      let ini = this.$refs.calendar.getIni();
     let fin = this.$refs.calendar.getFin();
     let aux = new Date(ini).getTime() + 2*60*60*1000;
     let ini1 = new Date(aux).toISOString()
     let fin1 = new Date(aux + 30*60*1000).toISOString()

     aux = new Date(fin).getTime() + 1 - 60*60*1000
     let ini2 = new Date(aux).toISOString()
     let fin2 = new Date(aux+30*60*1000).toISOString()

     
      let fechas = [];
      
      fechas.push(ini1)
      let aux3 = [];
      try {
        let aux = null;
        for (let it in events) {
          aux = new Object();
          Object.assign(aux, events[it]);
          for (let i = aux.start; i < aux.end; i += 30 * 60 * 1000) {
            let aux2 = {};
            Object.assign(aux2, aux);        
            let aux22 = new Date(i).toISOString()
            if(aux22 != ini1 && aux22 != ini2)fechas.push(aux22);
            aux2.start = i;
            aux2.end = i + 30 * 60 * 1000;
            aux3.push(aux2);
          }
          aux = null;
        }
        fechas.push(ini2)
        let data = {
          bloques: fechas,
          aprobado: true,
          
          idUnidad: this.currUnit
        };
        this.$api
          .addTutorAvailability(this.idTutor, data)
          .then(({ data }) => {
            this.$refs.calendar.ini();
            this.loading = false;
          })
          .catch(e => {
            this.$store.commit("setError", e);
            this.loading = false;
          });
      } catch (error) {
        this.$store.commit("setError", error);
      }
    },
    async Repeat(){
      this.loadingRep = true;
      let events = this.$refs.calendar.getEvents(this.currUnit); //[];
      let fechas = [];
      let aux3 = [];
      try {
        let aux = null;
        for (let it in events) {
          aux = new Object();
          Object.assign(aux, events[it]);
          for (let i = aux.start; i < aux.end; i += 30 * 60 * 1000) {
            let aux2 = {};
            Object.assign(aux2, aux);
            fechas.push(new Date(i).toISOString());
            aux2.start = i;
            aux2.end = i + 30 * 60 * 1000;
            aux3.push(aux2);
          }
          aux = null;
        }
        let ini = this.date[0] + 'T05:00:00.000Z'
        let fin = this.date[1] + 'T05:00:00.000Z'
        fin = new Date(new Date(fin).getTime() + 24*60*60*1000 - 1).toISOString()
        
        let data = {
          bloques: fechas,
            rangoFechas:{
                fechaInicio:ini,
                fechaFin:fin
            },
            
          idUnidad: this.currUnit
        }
        try {
           let response = await this.$api
           .replicateTutorAvailability(this.idTutor, data)
            this.$refs.calendar.ini();
       
        } catch (e) {
          this.$store.commit("setError", e);
        }
         this.loadingRep = false
        
      } catch (error) {
        this.$store.commit("setError", error);
      }
    },
    async iniDate(){
      let ini2 = "";
      let fin2 = 0;
      let curr = this.value;
      let tiempo = 0;
      let dia = new Date().getDay();
         tiempo = new Date().getTime();

        tiempo = tiempo - (dia - 1) * 24 * 60 * 60 * 1000 - 5 * 60 * 60 * 1000;
        curr = new Date(tiempo).toISOString().substr(0, 10);
      ini2 = curr + "T05:00:00.000Z";
      tiempo = new Date(ini2).getTime();
      fin2 = tiempo + 6 * 24 * 60 * 60 * 1000 - 1;
      //}
      let fin = new Date(fin2).toISOString().substr(0,10);
      let ini = new Date(ini2).toISOString().substr(0,10);
      this.date.push(ini)
      this.date.push(fin)
     try {
        let response = await this.$api.getTutorUnits(this.idTutor);
        this.units = response.data.data;
        this.ini = this.units[0].nombre
        this.currUnit = this.$store.state.role.idUnit

      } catch (e) {
        this.$store.commit("setError", e);
      }
    }
  },
  mounted() {
    this.iniDate()
  },
  computed: {
    dateRangeText() {
      this.date.sort((a, b) => (a > b ? 1 : -1));
      return this.date.join(" ~ ");
    },
    idTutor(){
      return this.$route.params.id
    },
    title(){
      return 'Horario de disponibilidad - ' + this.$store.state.names.tutor
    }
  },
  components: {
    "st-calendar": Calendar,
    "st-legend": ColorLegend
  }
};
</script>


<style scoped lang="scss">
.space {
  height: 50px;
}
</style>
